#!/usr/bin/perl
##############################################################################
# Megabook - Guestbook VIEW PRIVATE MESSAGES Script V1.1                     # 
# Copyright 2000 Terry Billinger                                             #
# Created 7/3/00                                                             #
# Available at http://www.militerry.com/megabook/                            #
##############################################################################
# COPYRIGHT NOTICE                                                           #
# Copyright 2000 Terry Billinger                                             #
#    								             #
# This script was made by combining Matt Riffle's Flexbook and               #
# Cliff Gdansk's Guestbook scripts.                                          #
# It allows for easy modification and easy administration.                   #
#                                                                            #
# This script can be used\modified free of charge as long as you don't       #
# change this header or any of the parts that give me credit for writing     #
# this.  By using this script you agree to indemnify me from any liability   #
# that might arise from its use.  In simple English, if this script somehow  #
# makes your computer run amuck and kill the pope, it's not my fault.        #
#                                                                            #
#                                                                            #
# Redistributing\selling the code for this program without prior written     #
# consent is expressly forbidden.                                            #
##############################################################################

print ("Content-type: text/html\n\n");

# Read in style and setup

open (SETUP, "setup.db");
@setup = <SETUP>;
close(SETUP);
$setupline = ($setup[0]);
chomp($setupline);
($title,$background,$bgcolor,$textcolor,$linkcolor,$vlinkcolor,$alinkcolor,$homepage,$mailprogram,$datafile,$success,$adminemail,$reverseentries,$allow_html,$entriesperpage,$maxentries,$mail_you,$guesspass,$bwfilter,$nextview,$backview,$privview,$adminpassword,$uplook,$downlook,$requiredfields,$fontface) = split(/\|/, $setupline);

# Get guestbook entries

open (DATA, "$datafile");
@data = reverse(<DATA>);
close(DATA);

if ($ENV{'QUERY_STRING'}) {

foreach (split('&', $ENV{'QUERY_STRING'})) {
        s/\+/ /g ;
        ($name, $value)= split('=', $_, 2) ;
        $name=~ s/%(..)/chr(hex($1))/ge ;
        $value=~ s/%(..)/chr(hex($1))/ge ;
        $INPUT{$name}.= "\0" if defined($INPUT{$name}) ;  # concatenate multiple vars
        $INPUT{$name}.= $value ;
    }
}

read(STDIN, $buffer, $ENV{'CONTENT_LENGTH'});
@pairs = split(/&/, $buffer);
foreach $pair (@pairs) {
        ($name, $value) = split(/=/, $pair);
        $value =~ tr/+/ /;
        $value =~ s/%([a-fA-F0-9][a-fA-F0-9])/pack("C", hex($1))/eg;
        $value =~ s/\s/ /g;
        $value =~ s/<([^>]|\n)*>//g;
        $value =~ s/<//g;
        $value =~ s/>//g;
        $FORM{$name} = $value;
}

# Decide what to do

if ($FORM{'action'} eq "view") { &view; }
if ($FORM{'action'} eq "viewip") {&viewip; }
else { &getpwd; }

sub getpwd {

print <<GETPASS;

<html><head><title>LOGIN</title></head><body bgcolor=FFFFFF>
<table border=0 cellpadding=5 cellspacing=0 width=100% height=100%>
<tr><td align=middle valign=middle>
<form method=POST>
GETPASS

if ($INPUT{'privateip'} eq "1") {
   print "<input type=hidden name=action value=viewip>\n";
} else {
   print "<input type=hidden name=action value=view>\n";
}

print <<GETPASS2;
<input type=hidden name=entryid value=$INPUT{'entryid'}>
<table border=0 cellpadding=3 cellspacing=0>
<tr>
   <td>
   <font face=arial size=1>Please enter admin password:</td>
   <td><input type=password size=8 name=password></td>
</tr>
<tr>
   <td></td>
   <td>
   <input type=submit value=View></td>
</tr>
</table>
</td>
</tr>
</table>
GETPASS2
}

sub checkpassword {

	if ($FORM{'password'} ne $adminpassword) {
		print "<html><head><title>$title - View Private Message - Bad password</title></head>\n";
                print "<body text=#000000 bgcolor=#ffffff>";
                print "<h1>Bad Password</h1><br>\n";
                print "The password you entered, $FORM{'password'}, is incorrect.\n";
		exit;
	}
}

sub view {

        &checkpassword;
	$num = ($FORM{'entryid'} - 1);
	$line = ($data[$num]);
	chomp($line);
	($name,$private,$email,$url,$comment,$date,$time,$var1,$var2,$var3,$var4,$var5,$var6,$ip,$browser) = split(/\|/, $line);

	if ($private ne "priv") {
		print "<html><title>Not a private entry</title>\n";
		print "<body text=#000000 bgcolor=#ffffff>\n";
		print "The entry you are trying to view is not a private entry.\n";
		print "</body></html>\n";
		exit;
	} else {
		print "<html><title>Private entry #$FORM{'entryid'}</title>";
		print "<body text=#000000 bgcolor=#ffffff>";
		print "<table width=100% height=100%>";
		print "<tr>";
		print "<td align=middle valign=middle>";
		print "<table border=0 cellpadding=0 cellspacing=0>";
		print "<tr>";
		print "<td width=280>";
		print "<font face=arial size=1>$comment<p>";
		print "<a href=javascript:self.close();>close</a>";
		print "</td></tr></table></td></tr></table></body></html>";
		exit;
	}
}

sub viewip {

        &checkpassword;
	$num = ($FORM{'entryid'} - 1);
	$line = ($data[$num]);
	chomp($line);
	($name,$private,$email,$url,$comment,$date,$time,$var1,$var2,$var3,$var4,$var5,$var6,$ip,$browser) = split(/\|/, $line);

	print "<html><title>Private entry #$FORM{'entryid'}</title>";
	print "<body text=#000000 bgcolor=#ffffff>";
	print "<table width=100% height=100%>";
	print "<tr>";
	print "<td align=middle valign=middle>";
	print "<table border=0 cellpadding=0 cellspacing=0>";
	print "<tr>";
	print "<td width=280>";
	print "<font face=arial size=1>$ip<p>";
	print "<a href=javascript:self.close();>close</a>";
	print "</td></tr></table></td></tr></table></body></html>";
	exit;
}